library rdpwrap;

uses
  SysUtils,
  Windows,
  //Classes,
  TlHelp32;

{$R rdpwrap.res}

// Hook core definitions

type
  OldCode = packed record
    One: DWORD;
    two: Word;
  end;

  far_jmp = packed record
    PushOp: Byte;
    PushArg: Pointer;
    RetOp: Byte;
  end;

  mov_far_jmp = packed record
    MovOp: Byte;
    MovArg: Byte;
    PushOp: Byte;
    PushArg: Pointer;
    RetOp: Byte;
  end;

  TTHREADENTRY32 = packed record
    dwSize: DWORD;
    cntUsage: DWORD;
    th32ThreadID: DWORD;
    th32OwnerProcessID: DWORD;
    tpBasePri: LongInt;
    tpDeltaPri: LongInt;
    dwFlags: DWORD;
  end;
  IntArray = Array of Integer;

const
  THREAD_SUSPEND_RESUME = 2;
  TH32CS_SNAPTHREAD = 4;
var
  bw: DWORD;
  Debug: Boolean = False;
  IsHooked: Boolean = False;
  FCount: Cardinal = 0;

// Unhooked import

function OpenThread(dwDesiredAccess: DWORD; bInheritHandle: BOOL;
  dwThreadId: DWORD): DWORD; stdcall; external kernel32;

function CreateToolhelp32Snapshot(dwFlags, th32ProcessID: DWORD): DWORD;
  stdcall; external kernel32;

function Thread32First(hSnapshot: THandle; var lpte: TTHREADENTRY32): bool;
  stdcall; external kernel32;

function Thread32Next(hSnapshot: THandle; var lpte: TTHREADENTRY32): bool;
  stdcall; external kernel32;

// Wrapped import

var
  TSMain: function(dwArgc: DWORD; lpszArgv: PWideChar): DWORD; stdcall;
  TSGlobals: function(lpGlobalData: Pointer): DWORD; stdcall;

// Hooked import and vars

var
  VerifyVersionInfo: function(lpVersionInfo: POSVERSIONINFOEXW; dwTypeMask: DWORD;
    dwlConditionMask: DWORDLONG): BOOL; stdcall;
  xxxWinStationQueryInformation: function(SessionId: ULONG;
    WinStationInformationClass: DWORD; pWinStationInformation: Pointer;
    WinStationInformationLength: ULONG; pReturnLength: PULONG): BOOL; stdcall;
  SLGetWindowsInformationDWORD: function(pwszValueName: PWideChar;
    pdwValue: PDWORD): HRESULT; stdcall;

const
  VER_EQUAL = 1;
  VER_OR = 7;
  VER_SUITENAME = $40;
  VER_PRODUCT_TYPE = $80;
  VER_SUITE_TERMINAL = $10;
  VER_SUITE_SINGLEUSERTS = $100;
  VER_SUITE_PERSONAL = $200;
  VER_NT_WORKSTATION = 1;

  Win8SL_func_sign: Array[0..15] of Byte = ($8B,$FF,$55,$8B,$EC,$81,$EC,$BC,$01,$00,$00,$53,$33,$C0,$8B,$D8);
var
  Addr_VerifyVersionInfo,
  Addr_Win8SL: Pointer; // 0x10019559 in IDA
  Stub_VerifyVersionInfo,
  Stub_xxxWinStationQueryInformation,
  Stub_SLGetWindowsInformationDWORD: far_jmp;
  Stub_Win8SL: mov_far_jmp;
  Old_VerifyVersionInfo,
  Old_xxxWinStationQueryInformation,
  Old_SLGetWindowsInformationDWORD: OldCode;
  Old_Win8SL: mov_far_jmp;

// Main code

procedure WriteLog(S: AnsiString);
//var
//  F: TFileStream;
begin
  if not Debug then Exit;
{  S := S+#13#10;
  F := TFileStream.Create('C:\test.txt', fmOpenReadWrite);
  F.Seek(F.Size, soFromBeginning);
  F.WriteBuffer(S[1], Length(S));
  F.Free; }
end;

procedure StopThreads;
var
  h, CurrTh, ThrHandle, CurrPr: DWORD;
  Thread: TTHREADENTRY32;
begin
  CurrTh := GetCurrentThreadId;
  CurrPr := GetCurrentProcessId;
  h := CreateToolhelp32Snapshot(TH32CS_SNAPTHREAD, 0);
  if h <> INVALID_HANDLE_VALUE then
  begin
    Thread.dwSize := SizeOf(TTHREADENTRY32);
    if Thread32First(h, Thread) then
      repeat
        if (Thread.th32ThreadID <> CurrTh) and
          (Thread.th32OwnerProcessID = CurrPr) then
        begin
          ThrHandle := OpenThread(THREAD_SUSPEND_RESUME, false,
            Thread.th32ThreadID);
          if ThrHandle > 0 then
          begin
            SuspendThread(ThrHandle);
            CloseHandle(ThrHandle);
          end;
        end;
      until not Thread32Next(h, Thread);
      CloseHandle(h);
  end;
end;

procedure RunThreads;
var
  h, CurrTh, ThrHandle, CurrPr: DWORD;
  Thread: TTHREADENTRY32;
begin
  CurrTh := GetCurrentThreadId;
  CurrPr := GetCurrentProcessId;
  h := CreateToolhelp32Snapshot(TH32CS_SNAPTHREAD, 0);
  if h <> INVALID_HANDLE_VALUE then
  begin
    Thread.dwSize := SizeOf(TTHREADENTRY32);
    if Thread32First(h, Thread) then
      repeat
        if (Thread.th32ThreadID <> CurrTh) and
          (Thread.th32OwnerProcessID = CurrPr) then
        begin
          ThrHandle := OpenThread(THREAD_SUSPEND_RESUME, false,
            Thread.th32ThreadID);
          if ThrHandle > 0 then
          begin
            ResumeThread(ThrHandle);
            CloseHandle(ThrHandle);
          end;
        end;
      until not Thread32Next(h, Thread);
      CloseHandle(h);
  end;
end;

function GetModuleAddress(ModuleName: String; ProcessId: DWORD; var BaseAddr: Pointer; var BaseSize: DWORD): Boolean;
var
  hSnap: THandle;
  md: MODULEENTRY32;
begin
  Result := False;
  hSnap := CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, ProcessId);
  if hSnap = INVALID_HANDLE_VALUE Then
    Exit;
  md.dwSize := SizeOf(MODULEENTRY32);
  if Module32First(hSnap, md) then
  begin
    if LowerCase(ExtractFileName(md.szExePath)) = LowerCase(ModuleName) then
    begin
      Result := True;
      BaseAddr := Pointer(md.modBaseAddr);
      BaseSize := md.modBaseSize;
      CloseHandle(hSnap);
      Exit;
    end;
    while Module32Next(hSnap, md) Do
    begin
      if LowerCase(ExtractFileName(md.szExePath)) = LowerCase(ModuleName) then
      begin
        Result := True;
        BaseAddr := Pointer(md.modBaseAddr);
        BaseSize := md.modBaseSize;
        Break;
      end;
    end;
  end;
  CloseHandle(hSnap);
end;

procedure FindMem(Mem: Pointer; MemSz: DWORD; Buf: Pointer; BufSz: DWORD;
  From: DWORD; var A: IntArray);
var
  I: Integer;
begin
  SetLength(A, 0);
  I:=From;
  if From>0 then
    Inc(PByte(Mem), From);
  while I < MemSz - BufSz + 1 do
  begin
    if (not IsBadReadPtr(Mem, BufSz)) and (CompareMem(Mem, Buf, BufSz)) then
    begin
      SetLength(A, Length(A)+1);
      A[Length(A)-1] := I;
    end;
    Inc(I);
    Inc(PByte(Mem));
  end;
end;

function New_VerifyVersionInfo(lpVersionInfo: POSVERSIONINFOEXW; dwTypeMask: DWORD;
  dwlConditionMask: UInt64): BOOL; stdcall;
var
  dw: DWORD;
begin
  WriteLog('dwTypeMask: '+IntToStr(dwTypeMask));
  WriteLog('dwlConditionMask: '+IntToStr(dwlConditionMask));
  // wrapped VerifyVersionInfo function
  // termsrv.dll will call this function instead of original kernel32.dll

  // Override version verify

  // IsTerminalServicesEnabled
  if (lpVersionInfo.wSuiteMask = VER_SUITE_TERMINAL or VER_SUITE_SINGLEUSERTS)
  and (dwTypeMask = VER_SUITENAME)
  and (dwlConditionMask = $80000000001C0000) then // 9223372036856610816
  begin
    WriteLog('IsTerminalServicesEnabled patched!');
    Result := True; // listeners enabled (not starter edition)
    Exit;
  end;
  // g_bPersonalWks
  if (lpVersionInfo.wSuiteMask = VER_SUITE_PERSONAL)
  and (lpVersionInfo.wProductType = VER_NT_WORKSTATION)
  and (dwTypeMask = VER_PRODUCT_TYPE or VER_SUITENAME)
  and (dwlConditionMask = $80000000003C0000) then // 9223372036858707968
  begin
    WriteLog('g_bPersonalWks patched!');
    Result := False; // not home edition
    SetLastError(ERROR_OLD_WIN_VERSION);
    Exit;
  end;
  // g_bPersonalTS
  if (lpVersionInfo.wSuiteMask = VER_SUITE_SINGLEUSERTS)
  and (lpVersionInfo.wProductType = VER_NT_WORKSTATION)
  and (dwTypeMask = VER_PRODUCT_TYPE or VER_SUITENAME)
  and (dwlConditionMask = $80000000003C0000) then // 9223372036858707968
  begin
    WriteLog('g_bPersonalTS patched!');
    Result := False; // not personal remote desktop
    SetLastError(ERROR_OLD_WIN_VERSION);
    Exit;
  end;
  // gbServer
  if (lpVersionInfo.wProductType = VER_NT_WORKSTATION)
  and (dwTypeMask = VER_PRODUCT_TYPE)
  and (dwlConditionMask = $8000000000200000) then // 9223372036856872960
  begin
    WriteLog('gbServer patched!');
    Result := False; // not a workstation
    SetLastError(ERROR_OLD_WIN_VERSION);
    Exit;
  end;

  // If the arguments is not defined above

  // revert to original SL Policy function
  WriteProcessMemory(GetCurrentProcess, @VerifyVersionInfo,
    @Old_VerifyVersionInfo, SizeOf(OldCode), bw);

  // get result
  Result := VerifyVersionInfo(lpVersionInfo, dwTypeMask, dwlConditionMask);

  // wrap it back
  WriteProcessMemory(GetCurrentProcess, @VerifyVersionInfo,
    @Stub_VerifyVersionInfo, SizeOf(far_jmp), bw);
end;

function New_xxxWinStationQueryInformation(SessionId: ULONG;
  WinStationInformationClass: DWORD; pWinStationInformation: Pointer;
  WinStationInformationLength: ULONG; pReturnLength: PULONG): BOOL; stdcall;
//var
//  F: TFileStream;
begin
  WriteProcessMemory(GetCurrentProcess, @xxxWinStationQueryInformation,
    @Old_xxxWinStationQueryInformation, SizeOf(OldCode), bw);

  Result := xxxWinStationQueryInformation(SessionId, WinStationInformationClass,
  pWinStationInformation, WinStationInformationLength, pReturnLength);

  WriteProcessMemory(GetCurrentProcess, @xxxWinStationQueryInformation,
    @Stub_xxxWinStationQueryInformation, SizeOf(far_jmp), bw);

  {WriteLog('SessionId: '+IntToStr(SessionId));
  WriteLog('WinStationInformationClass: '+IntToStr(WinStationInformationClass));
  if WinStationInformationLength >= pReturnLength^ then begin
    F := TFileStream.Create('C:\'+IntToStr(FCount)+'.raw', fmCreate);
    F.WriteBuffer(pWinStationInformation^, pReturnLength^);
    F.Free;
    WriteLog('Buffer: C:\'+IntToStr(FCount)+'.raw');
    Inc(FCount);
  end;}
end;

function OverrideSL(ValueName: String; var Value: DWORD): Boolean;
begin
  Result := True;
  if ValueName = 'TerminalServices-RemoteConnectionManager-AllowRemoteConnections' then begin
    Value := 1;
    Exit;
  end;
  if ValueName = 'TerminalServices-RemoteConnectionManager-AllowMultipleSessions' then begin
    Value := 1;
    Exit;
  end;
  if ValueName = 'TerminalServices-RemoteConnectionManager-AllowAppServerMode' then begin
    Value := 1;
    Exit;
  end;
  if ValueName = 'TerminalServices-RemoteConnectionManager-AllowMultimon' then begin
    Value := 1;
    Exit;
  end;
  if ValueName = 'TerminalServices-RemoteConnectionManager-MaxUserSessions' then begin
    Value := 0;
    Exit;
  end;
  if ValueName = 'TerminalServices-RemoteConnectionManager-45344fe7-00e6-4ac6-9f01-d01fd4ffadfb-MaxSessions' then begin
    Value := 2;
    Exit;
  end;
  if ValueName = 'TerminalServices-RDP-7-Advanced-Compression-Allowed' then begin
    Value := 1;
    Exit;
  end;
  if ValueName = 'TerminalServices-RemoteConnectionManager-45344fe7-00e6-4ac6-9f01-d01fd4ffadfb-LocalOnly' then begin
    Value := 0;
    Exit;
  end;
  if ValueName = 'TerminalServices-RemoteConnectionManager-8dc86f1d-9969-4379-91c1-06fe1dc60575-MaxSessions' then begin
    Value := 1000;
    Exit;
  end;
  Result := False;
end;

function New_SLGetWindowsInformationDWORD(pwszValueName: PWideChar;
  pdwValue: PDWORD): HRESULT; stdcall;
var
  dw: DWORD;
begin
  // wrapped SLGetWindowsInformationDWORD function
  // termsrv.dll will call this function instead of original SLC.dll

  // Override SL Policy

  if OverrideSL(pwszValueName, dw) then begin
    pdwValue^ := dw;
    Result := S_OK;
    Exit;
  end;

  // If the requested value name is not defined above

  // revert to original SL Policy function
  WriteProcessMemory(GetCurrentProcess, @SLGetWindowsInformationDWORD,
    @Old_SLGetWindowsInformationDWORD, SizeOf(OldCode), bw);

  // get result
  Result := SLGetWindowsInformationDWORD(pwszValueName, pdwValue);

  // wrap it back
  WriteProcessMemory(GetCurrentProcess, @SLGetWindowsInformationDWORD,
    @Stub_SLGetWindowsInformationDWORD, SizeOf(far_jmp), bw);
end;

function New_Win8SL(pwszValueName: PWideChar; pdwValue: PDWORD): HRESULT; register;
var
  dw: DWORD;
begin
  // wrapped unexported function in termsrv.dll
  // for Windows 8 Single Language support

  // Override SL Policy

  if OverrideSL(pwszValueName, dw) then begin
    pdwValue^ := dw;
    Result := S_OK;
    Exit;
  end;

  // If the requested value name is not defined above
  // ...but use function from SLC.dll

  // revert to original SL Policy function
  WriteProcessMemory(GetCurrentProcess, @SLGetWindowsInformationDWORD,
    @Old_SLGetWindowsInformationDWORD, SizeOf(OldCode), bw);

  // get result
  Result := SLGetWindowsInformationDWORD(pwszValueName, pdwValue);

  // wrap it back
  WriteProcessMemory(GetCurrentProcess, @SLGetWindowsInformationDWORD,
    @Stub_SLGetWindowsInformationDWORD, SizeOf(far_jmp), bw);
end;

procedure HookFunctions;
var
  V: DWORD;
  TS_Handle, Krnl_Handle, SLC_Handle: THandle;
  TermSrvBase: Pointer;
  TermSrvSize: DWORD;
  Results: IntArray;
begin
  { hook function ^^
     (called once)   }
  IsHooked := True;
  TSMain := nil;
  TSGlobals := nil;
  VerifyVersionInfo := nil;
  SLGetWindowsInformationDWORD := nil;
  WriteLog('init');

  // load termsrv.dll and get functions
  TS_Handle := LoadLibrary('termsrv.dll');
  WriteLog('TS_Handle: '+IntToHex(TS_Handle, 8));
  TSMain := GetProcAddress(TS_Handle, 'ServiceMain');
  WriteLog('TSMain: '+IntToHex(Cardinal(@TSMain), 8));
  TSGlobals := GetProcAddress(TS_Handle, 'SvchostPushServiceGlobals');
  WriteLog('TSGlobals: '+IntToHex(Cardinal(@TSGlobals), 8));

  // check NT version
  V := GetVersion;
  V := ((V and $FF) shl 8) or ((V and $FF00) shr 8);
  WriteLog('Ver: '+IntToHex(V, 4));

  // temporarily freeze threads
  WriteLog('freeze');
  StopThreads();

  if V < $0600 then begin
    WriteLog('XP');
    // XP | 2003
    // uses VerifyVersionInfo function
	
	// under construction

    { Krnl_Handle := GetModuleHandle(kernel32);
    WriteLog('Krnl_Handle: '+IntToHex(Krnl_Handle, 8));
    VerifyVersionInfo := GetProcAddress(Krnl_Handle, 'VerifyVersionInfoW');
    WriteLog('VerifyVersionInfo: '+IntToHex(Cardinal(@VerifyVersionInfo), 8));

    if @VerifyVersionInfo <> nil then
    begin
      // rewrite original function to call our function (make hook)
      Stub_VerifyVersionInfo.PushOp := $68;
      Stub_VerifyVersionInfo.PushArg := @New_VerifyVersionInfo;
      Stub_VerifyVersionInfo.RetOp := $C3;
      ReadProcessMemory(GetCurrentProcess, @VerifyVersionInfo,
        @Old_VerifyVersionInfo, SizeOf(OldCode), bw);
      WriteProcessMemory(GetCurrentProcess, @VerifyVersionInfo,
        @Stub_VerifyVersionInfo, SizeOf(far_jmp), bw);
      WriteLog('rewrited');
    end;

    xxxWinStationQueryInformation := Pointer($752E45E3);
    Stub_xxxWinStationQueryInformation.PushOp := $68;
    Stub_xxxWinStationQueryInformation.PushArg := @New_xxxWinStationQueryInformation;
    Stub_xxxWinStationQueryInformation.RetOp := $C3;
    ReadProcessMemory(GetCurrentProcess, @xxxWinStationQueryInformation,
      @Old_xxxWinStationQueryInformation, SizeOf(OldCode), bw);
    WriteProcessMemory(GetCurrentProcess, @xxxWinStationQueryInformation,
      @Stub_xxxWinStationQueryInformation, SizeOf(far_jmp), bw); }

  end else begin
    // Vista | 7 | 8 | 8.1
    // uses SL Policy API

    // load slc.dll and get functions
    SLC_Handle := LoadLibrary('slc.dll');
    SLGetWindowsInformationDWORD := GetProcAddress(SLC_Handle, 'SLGetWindowsInformationDWORD');

    if @SLGetWindowsInformationDWORD <> nil then
    begin
      // rewrite original function to call our function (make hook)
      Stub_SLGetWindowsInformationDWORD.PushOp := $68;
      Stub_SLGetWindowsInformationDWORD.PushArg := @New_SLGetWindowsInformationDWORD;
      Stub_SLGetWindowsInformationDWORD.RetOp := $C3;
      ReadProcessMemory(GetCurrentProcess, @SLGetWindowsInformationDWORD,
        @Old_SLGetWindowsInformationDWORD, SizeOf(OldCode), bw);
      WriteProcessMemory(GetCurrentProcess, @SLGetWindowsInformationDWORD,
        @Stub_SLGetWindowsInformationDWORD, SizeOf(far_jmp), bw);
    end;

    if V >= $0602 then begin
      // Windows 8 or higher
      // uses internal unexported function

      if GetModuleAddress('termsrv.dll', GetCurrentProcessId, TermSrvBase, TermSrvSize) then begin
        // search for internal function
        SetLength(Results, 0);
        FindMem(TermSrvBase, TermSrvSize, @Win8SL_func_sign[0], 16, 0, Results);
        if Length(Results) >= 1 then begin
          Addr_Win8SL := Pointer(Cardinal(TermSrvBase) + Results[0]);
          if CompareMem(@Win8SL_func_sign[0], Addr_Win8SL, 16) then begin
            Stub_Win8SL.MovOp := $89;  // mov eax, ecx
            Stub_Win8SL.MovArg := $C8; // __msfastcall compatibility
            Stub_Win8SL.PushOp := $68;
            Stub_Win8SL.PushArg := @New_Win8SL;
            Stub_Win8SL.RetOp := $C3;
            ReadProcessMemory(GetCurrentProcess, Addr_Win8SL,
              @Old_Win8SL, SizeOf(mov_far_jmp), bw);
            WriteProcessMemory(GetCurrentProcess, Addr_Win8SL,
              @Stub_Win8SL, SizeOf(mov_far_jmp), bw);
          end;
        end;
      end;
    end;

  end;

  // unfreeze threads
  WriteLog('resume');
  RunThreads();
end;

function TermServiceMain(dwArgc: DWORD; lpszArgv: PWideChar): DWORD; stdcall;
begin
  // wrap ServiceMain function
  WriteLog('ServiceMain');
  if not IsHooked then
    HookFunctions;
  Result := 0;
  if @TSMain <> nil then
    Result := TSMain(dwArgc, lpszArgv);
end;

function TermServiceGlobals(lpGlobalData: Pointer): DWORD; stdcall;
begin
  // wrap SvchostPushServiceGlobals function
  WriteLog('SvchostPushServiceGlobals');
  if not IsHooked then
    HookFunctions;
  Result := 0;
  if @TSGlobals <> nil then
    Result := TSGlobals(lpGlobalData);
end;

// export section

exports
  TermServiceMain index 1 name 'ServiceMain';
exports
  TermServiceGlobals index 2 name 'SvchostPushServiceGlobals';

begin
  // DllMain procedure is not used
end.