// RDPWrap C++ port by Fusix (Nikita Parshin)
// assisted by binarymaster (Stas'M)

#include "stdafx.h"


#ifdef _WIN64
typedef unsigned long long PLATFORM_DWORD;
struct FARJMP
{	// x64 far jump | opcode | assembly
	BYTE MovOp;		// 48	mov rax, ptr
	BYTE MovRegArg;	// B8
	DWORD64 MovArg;	// PTR
	BYTE PushRaxOp; // 50	push rax
	BYTE RetOp;		// C3	retn
};
// x64 signatures

// termsrv.dll build 6.2.9200.16384
char Win8SL_FuncSign[] = {0x48, 0x89, 0x5C, 0x24, 0x18, 0x55, 0x56, 0x57, 0x41, 0x54, 0x41, 0x55, 0x41, 0x56, 0x41, 0x57, 0x48, 0x8D, 0xAC, 0x24, 0x60, 0xFE, 0xFF, 0xFF, 0x48, 0x81, 0xEC, 0xA0, 0x02, 0x00, 0x00, 0x33};

// termsrv.dll build 6.3.9600.16384
// for testing purposes; not working...
char Win81SL_FuncSign[] = {0xBA, 0xFF, 0xFF, 0xFF, 0x7F, 0x45, 0x33, 0xC9, 0x8B, 0xC2, 0x66, 0x0F, 0x1F, 0x04, 0x00, 0x66, 0x44, 0x39, 0x09, 0x74, 0x0E, 0x48, 0x83, 0xC1, 0x02, 0x48, 0xFF, 0xC8, 0x75, 0xF1, 0xE9, 0xC8};

#else
typedef unsigned long PLATFORM_DWORD;
struct FARJMP
{	// x86 far jump | opcode | assembly
	BYTE PushOp;	// 68	push ptr
	DWORD PushArg;	// PTR
	BYTE RetOp;		// C3	retn
};
// x86 signatures

// termsrv.dll build 6.2.9200.16384
// HRESULT __fastcall SLGetWindowsInformationDWORDWrapper(PWSTR pwszValueName, DWORD *pdwValue)
char Win8SL_FuncSign[] = {0x8B, 0xFF, 0x55, 0x8B, 0xEC, 0x81, 0xEC, 0xBC, 0x01, 0x00, 0x00, 0x53, 0x33, 0xC0, 0x8B, 0xD8};

// termsrv.dll build 6.3.9600.16384 is not supported
// reason: too many code replacements is required, we are too lazy... :)
// function call replaced with duplicated code templates %) it's really hard to realize
#endif

FARJMP Old_SLGetWindowsInformationDWORD, Stub_SLGetWindowsInformationDWORD;
FARJMP Old_Win8SL, Stub_Win8SL;
SLGETWINDOWSINFORMATIONDWORD _SLGetWindowsInformationDWORD;

HMODULE hTermSrv;
HMODULE hSLC;
SERVICEMAIN _ServiceMain;
SVCHOSTPUSHSERVICEGLOBALS _SvchostPushServiceGlobals;
bool AlreadyHooked = false;

void WriteToLog(LPSTR Text)
{
	DWORD dwBytesOfWritten;

	HANDLE hFile = CreateFile(L"C:\\RDPWrap.txt", GENERIC_WRITE, FILE_SHARE_WRITE|FILE_SHARE_READ, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE) return;

	SetFilePointer(hFile, 0, 0, FILE_END);
	WriteFile(hFile, Text, strlen(Text), &dwBytesOfWritten, NULL);
	CloseHandle(hFile);
}

PLATFORM_DWORD SearchAddressBySignature(char *StartPosition, PLATFORM_DWORD Size, char *Signature, int SignatureSize)
{
	PLATFORM_DWORD AddressReturn = -1;

	char *Log = new char[1024];
	wsprintfA(Log, "Call: SearchAddressBySignature\r\nArgs: StartPosition: 0x%p, Size: 0x%p, Signature: 0x%p, SignSize: %i\r\n", StartPosition, Size, Signature, SignatureSize);
	WriteToLog(Log);
	delete[] Log;
					
	for(PLATFORM_DWORD i = 0; i < Size; i++)
	{
		for(int j = 0; StartPosition[i+j] == Signature[j] && j < SignatureSize; j++)
		{
			if(j == SignatureSize-1) AddressReturn = (PLATFORM_DWORD)&StartPosition[i];
		}
	}

	Log = new char[1024];
	wsprintfA(Log, "Retn: SearchAddressBySignature - 0x%p\r\n", AddressReturn);
	WriteToLog(Log);
	delete[] Log;

	return AddressReturn;
}

bool GetModuleCodeSectionInfo(HMODULE hModule, PLATFORM_DWORD *BaseAddr, PLATFORM_DWORD *BaseSize)
{
	PIMAGE_DOS_HEADER		pDosHeader;
	PIMAGE_FILE_HEADER      pFileHeader;
	PIMAGE_OPTIONAL_HEADER  pOptionalHeader;

	char *Log = new char[1024];
	wsprintfA(Log, "Call: GetModuleCodeSectionInfo\r\nArgs: hModule: 0x%p, *BaseAddr: 0x%p, *BaseSize: 0x%p\r\n", hModule, BaseAddr, BaseSize);
	WriteToLog(Log);
	delete[] Log;

	if(hModule == NULL) return false;

	pDosHeader = (PIMAGE_DOS_HEADER)hModule;
	pFileHeader = (PIMAGE_FILE_HEADER)(((PBYTE)hModule)+pDosHeader->e_lfanew+4);
	pOptionalHeader = (PIMAGE_OPTIONAL_HEADER)(pFileHeader+1);

	*BaseAddr = (PLATFORM_DWORD)hModule;
	*BaseSize = (PLATFORM_DWORD)pOptionalHeader->SizeOfCode;

	Log = new char[1024];
	wsprintfA(Log, "Retn: GetModuleCodeSectionInfo - BaseAddr: 0x%p, BaseSize: 0x%p\r\n", hModule, *BaseSize);
	WriteToLog(Log);
	delete[] Log;

	if(*BaseAddr <= 0 || *BaseSize <= 0) return false;
	return true;
}

void SetThreadsState(bool Resume)
{
	HANDLE h, ThrHandle;
	DWORD CurrTh, CurrPr;
	THREADENTRY32 Thread;

	WriteToLog("Call: SetThreadsState\r\n");

	CurrTh = GetCurrentThreadId();
	CurrPr = GetCurrentProcessId();
	
	h = CreateToolhelp32Snapshot(TH32CS_SNAPTHREAD, 0);
	if(h != INVALID_HANDLE_VALUE)
	{
		Thread.dwSize = sizeof(THREADENTRY32);
		Thread32First(h, &Thread);
		do
		{
			if(Thread.th32ThreadID != CurrTh && Thread.th32OwnerProcessID == CurrPr)
			{
				ThrHandle = OpenThread(THREAD_SUSPEND_RESUME, false, Thread.th32ThreadID);
				if(ThrHandle != INVALID_HANDLE_VALUE)
				{
					if(Resume)		ResumeThread(ThrHandle);
					else			SuspendThread(ThrHandle);
					CloseHandle(ThrHandle);
				}
			}
		} while(Thread32Next(h, &Thread));	
		CloseHandle(h);
	}
	WriteToLog("Retn: SetThreadsState\r\n");
}

bool OverrideSL(LPWSTR ValueName, DWORD *Value)
{
	if(wcscmp(ValueName, L"TerminalServices-RemoteConnectionManager-AllowRemoteConnections") == 0)
	{
		*Value = 1;
		return true;
	}
	if(wcscmp(ValueName, L"TerminalServices-RemoteConnectionManager-AllowMultipleSessions") == 0)
	{
		*Value = 1;
		return true;
	}
	if(wcscmp(ValueName, L"TerminalServices-RemoteConnectionManager-AllowAppServerMode") == 0)
	{
		*Value = 1;
		return true;
	}
	if(wcscmp(ValueName, L"TerminalServices-RemoteConnectionManager-AllowMultimon") == 0)
	{
		*Value = 1;
		return true;
	}
	if(wcscmp(ValueName, L"TerminalServices-RemoteConnectionManager-MaxUserSessions") == 0)
	{
		*Value = 0;
		return true;
	}
	if(wcscmp(ValueName, L"TerminalServices-RemoteConnectionManager-45344fe7-00e6-4ac6-9f01-d01fd4ffadfb-MaxSessions") == 0)
	{
		*Value = 2;
		return true;
	}
	if(wcscmp(ValueName, L"TerminalServices-RDP-7-Advanced-Compression-Allowed") == 0)
	{
		*Value = 1;
		return true;
	}
	if(wcscmp(ValueName, L"TerminalServices-RemoteConnectionManager-45344fe7-00e6-4ac6-9f01-d01fd4ffadfb-LocalOnly") == 0)
	{
		*Value = 0;
		return true;
	}
	if(wcscmp(ValueName, L"TerminalServices-RemoteConnectionManager-8dc86f1d-9969-4379-91c1-06fe1dc60575-MaxSessions") == 0)
	{
		*Value = 1000;
		return true;	
	}
	return false;
}

HRESULT WINAPI New_SLGetWindowsInformationDWORD(PWSTR pwszValueName, DWORD *pdwValue)
{
	extern FARJMP Old_SLGetWindowsInformationDWORD, Stub_SLGetWindowsInformationDWORD;
	extern SLGETWINDOWSINFORMATIONDWORD _SLGetWindowsInformationDWORD;

	char *Log;
	DWORD dw;
	SIZE_T bw;
	HRESULT Result;

	Log = new char[1024];
	wsprintfA(Log, "Call: New_SLGetWindowsInformation\r\nArgs: pwszValueName: %S, pdwValue: %i\r\n", pwszValueName, *pdwValue);
	WriteToLog(Log);
	delete[] Log;

	if(OverrideSL(pwszValueName, &dw))
	{
		Log = new char[1024];
		wsprintfA(Log, "New_SLGetWindowsInformation: rewrite %S -> %i\r\n", pwszValueName, dw);
		WriteToLog(Log);
		delete[] Log;

		*pdwValue = dw;
		return S_OK; 
	}

	WriteProcessMemory(GetCurrentProcess(), _SLGetWindowsInformationDWORD, &Old_SLGetWindowsInformationDWORD, sizeof(FARJMP), &bw);
	Result = _SLGetWindowsInformationDWORD(pwszValueName, pdwValue);
	WriteProcessMemory(GetCurrentProcess(), _SLGetWindowsInformationDWORD, &Stub_SLGetWindowsInformationDWORD, sizeof(FARJMP), &bw);

	WriteToLog("Retn: New_SLGetWindowsInformation");
	return Result;
}

HRESULT __fastcall New_Win8SL(PWSTR pwszValueName, DWORD *pdwValue)
{
	extern FARJMP Old_SLGetWindowsInformationDWORD, Stub_SLGetWindowsInformationDWORD;
	extern FARJMP Old_Win8SL, Stub_Win8SL;
	extern SLGETWINDOWSINFORMATIONDWORD _SLGetWindowsInformationDWORD;

	char *Log;
	DWORD dw;
	SIZE_T bw;
	HRESULT Result;

	Log = new char[1024];
	wsprintfA(Log, "Call: New_Win8SL\r\nArgs: pwszValueName: %S, pdwValue: %i\r\n", pwszValueName, *pdwValue);
	WriteToLog(Log);
	delete[] Log;

	if(OverrideSL(pwszValueName, &dw))
	{
		Log = new char[1024];
		wsprintfA(Log, "New_Win8SL: %S -> %i\r\n", pwszValueName, dw);
		WriteToLog(Log);
		delete[] Log;

		*pdwValue = dw;
		WriteToLog("Ret: New_Win8SL\r\n");
		return S_OK; 
	}

	WriteProcessMemory(GetCurrentProcess(), _SLGetWindowsInformationDWORD, &Old_SLGetWindowsInformationDWORD, sizeof(FARJMP), &bw);
	Result = _SLGetWindowsInformationDWORD(pwszValueName, pdwValue);
	WriteProcessMemory(GetCurrentProcess(), _SLGetWindowsInformationDWORD, &Stub_SLGetWindowsInformationDWORD, sizeof(FARJMP), &bw);
	
	WriteToLog("Ret: New_Win8SL\r\n");

	return Result;
}

// for testing purposes; not working...
HRESULT __fastcall New_Win81SL(PWSTR pwszValueName, DWORD Reserved, DWORD *pdwValue)
{
	extern FARJMP Old_SLGetWindowsInformationDWORD, Stub_SLGetWindowsInformationDWORD;
	extern FARJMP Old_Win8SL, Stub_Win8SL;
	extern SLGETWINDOWSINFORMATIONDWORD _SLGetWindowsInformationDWORD;

	char *Log;
	DWORD dw;
	SIZE_T bw;
	HRESULT Result;

	Log = new char[1024];
	wsprintfA(Log, "Call: New_Win81SL\r\nArgs: pwszValueName: %S, pdwValue: %i\r\n", pwszValueName, *pdwValue);
	WriteToLog(Log);
	delete[] Log;

	if(OverrideSL(pwszValueName, &dw))
	{
		Log = new char[1024];
		wsprintfA(Log, "New_Win81SL: rewrite %S -> %i\r\n", pwszValueName, dw);
		WriteToLog(Log);
		delete[] Log;

		*pdwValue = dw;
		WriteToLog("Ret: New_Win81SL\r\n");
		return S_OK; 
	}

	WriteProcessMemory(GetCurrentProcess(), _SLGetWindowsInformationDWORD, &Old_SLGetWindowsInformationDWORD, sizeof(FARJMP), &bw);
	Result = _SLGetWindowsInformationDWORD(pwszValueName, pdwValue);
	WriteProcessMemory(GetCurrentProcess(), _SLGetWindowsInformationDWORD, &Stub_SLGetWindowsInformationDWORD, sizeof(FARJMP), &bw);
	
	WriteToLog("Ret: New_Win81SL\r\n");

	return Result;
}

#ifdef _WIN64
void Hook()
{
	// x64 hook
	extern FARJMP Old_SLGetWindowsInformationDWORD, Stub_SLGetWindowsInformationDWORD;
	extern FARJMP Old_Win8SL, Stub_Win8SL;
	extern SLGETWINDOWSINFORMATIONDWORD _SLGetWindowsInformationDWORD;
	extern HMODULE hTermSrv;
	extern HMODULE hSLC;
	extern bool sAlreadyHooked;

	AlreadyHooked = true;

	bool Result;
	char *Log;
	SIZE_T bw;
	DWORD OsVersion;
	PLATFORM_DWORD TermSrvBase, TermSrvSize;

	WriteToLog("Call: Hook\r\n");

	hTermSrv = LoadLibrary(L"termsrv.dll");
	_ServiceMain = (SERVICEMAIN)GetProcAddress(hTermSrv, "ServiceMain");
	_SvchostPushServiceGlobals = (SVCHOSTPUSHSERVICEGLOBALS)GetProcAddress(hTermSrv, "SvchostPushServiceGlobals");

	SetThreadsState(false);

	OsVersion = GetVersion();
	OsVersion = ((OsVersion & 0xFF) << 8) | ((OsVersion & 0xFF00) >> 8);

	Log = new char[1024];
	wsprintfA(Log, "Hook: OS Version: 0x%p\r\n", OsVersion);
	WriteToLog(Log);
	delete[] Log;

	if(OsVersion < 0x0600)
	{
	    // XP | 2003
		// uses VerifyVersionInfo function
	}
	else 
	{
	    // Vista | 7 | 8 | 8.1
	    // uses SL Policy API

		hSLC = LoadLibrary(L"slc.dll");
		_SLGetWindowsInformationDWORD = (SLGETWINDOWSINFORMATIONDWORD)GetProcAddress(hSLC, "SLGetWindowsInformationDWORD");
		if(_SLGetWindowsInformationDWORD == INVALID_HANDLE_VALUE) return;
		
		Stub_SLGetWindowsInformationDWORD.MovOp = 0x48;
		Stub_SLGetWindowsInformationDWORD.MovRegArg = 0xB8;
		Stub_SLGetWindowsInformationDWORD.MovArg =  (PLATFORM_DWORD)New_SLGetWindowsInformationDWORD;
		Stub_SLGetWindowsInformationDWORD.PushRaxOp = 0x50;
		Stub_SLGetWindowsInformationDWORD.RetOp = 0xC3;

		Log = new char[1024];
		wsprintfA(Log, "Hook: MovArg: 0x%p (SLGetWindowsInformation)\r\n", (PLATFORM_DWORD)New_SLGetWindowsInformationDWORD);
		WriteToLog(Log);
		delete[] Log;

		ReadProcessMemory(GetCurrentProcess(), _SLGetWindowsInformationDWORD, &Old_SLGetWindowsInformationDWORD, sizeof(FARJMP), &bw);
		WriteProcessMemory(GetCurrentProcess(), _SLGetWindowsInformationDWORD, &Stub_SLGetWindowsInformationDWORD, sizeof(FARJMP), &bw);

		if(OsVersion >= 0x0602) // if Windows 8 or higher
		{
			if(GetModuleCodeSectionInfo(hTermSrv, &TermSrvBase, &TermSrvSize))
			{
				WriteToLog("Hook: Windows 8 detected\r\n");

				Stub_Win8SL.MovOp = 0x48;
				Stub_Win8SL.MovRegArg = 0xB8;

				// Trying Windows 8 signature
				WriteToLog("Hook: Trying Windows 8 signature\r\n");
				PLATFORM_DWORD Win8SL_Func = SearchAddressBySignature((char*)TermSrvBase, TermSrvSize, Win8SL_FuncSign, sizeof(Win8SL_FuncSign));
				if(Win8SL_Func > 0)
				{
					Stub_Win8SL.MovArg = (PLATFORM_DWORD)New_Win8SL;
				}
				if(Win8SL_Func == -1) 
				{
					// Trying Windows 8.1 signature
					WriteToLog("Hook: Windows is not supported!\r\n");		
					return;
					WriteToLog("Hook: Trying Windows 8.1 signature\r\n");
					Win8SL_Func = SearchAddressBySignature((char*)TermSrvBase, TermSrvSize, Win81SL_FuncSign, sizeof(Win81SL_FuncSign));
					if(Win8SL_Func > 0)
					{
						Stub_Win8SL.MovArg = (PLATFORM_DWORD)New_Win81SL;
					}
				}
				if(Win8SL_Func == -1)
				{
					WriteToLog("Signatures not found.\r\nReturn from: Hook\r\n");
					return;
				}

				Stub_Win8SL.PushRaxOp = 0x50;
				Stub_Win8SL.RetOp = 0xC3;
				
				Log = new char[1024];
				wsprintfA(Log, "Hook: MovArg: 0x%p (Win8*SLGet)\r\n", TermSrvBase, Win8SL_Func);
				WriteToLog(Log);
				delete[] Log;

				ReadProcessMemory(GetCurrentProcess(), (LPVOID)Win8SL_Func, &Old_Win8SL, sizeof(FARJMP), &bw);
				WriteProcessMemory(GetCurrentProcess(), (LPVOID)Win8SL_Func, &Stub_Win8SL, sizeof(FARJMP), &bw);
				WriteToLog("Hook: Success\r\n");
			}
		}
	}
	SetThreadsState(true);
	WriteToLog("Retn: Hook\r\n");
	return;
}
#else
void Hook()
{
	// x86 hook
	extern FARJMP Old_SLGetWindowsInformationDWORD, Stub_SLGetWindowsInformationDWORD;
	extern FARJMP Old_Win8SL, Stub_Win8SL;
	extern SLGETWINDOWSINFORMATIONDWORD _SLGetWindowsInformationDWORD;
	extern HMODULE hTermSrv;
	extern HMODULE hSLC;

	bool Result;
	char *Log;
	SIZE_T bw;
	DWORD OsVersion;
	PLATFORM_DWORD TermSrvBase, TermSrvSize;

	WriteToLog("Call: Hook\r\n");

	hTermSrv = LoadLibrary(L"termsrv.dll");
	_ServiceMain = (SERVICEMAIN)GetProcAddress(hTermSrv, "ServiceMain");
	_SvchostPushServiceGlobals = (SVCHOSTPUSHSERVICEGLOBALS)GetProcAddress(hTermSrv, "SvchostPushServiceGlobals");

	SetThreadsState(false);

	OsVersion = GetVersion();
	OsVersion = ((OsVersion & 0xFF) << 8) | ((OsVersion & 0xFF00) >> 8);
	
	if(OsVersion < 0x0600)
	{
	    // XP | 2003
		// uses VerifyVersionInfo function
	}
	else 
	{
	    // Vista | 7 | 8 | 8.1
	    // uses SL Policy API

		hSLC = LoadLibrary(L"slc.dll");
		_SLGetWindowsInformationDWORD = (SLGETWINDOWSINFORMATIONDWORD)GetProcAddress(hSLC, "SLGetWindowsInformationDWORD");
		if(_SLGetWindowsInformationDWORD == INVALID_HANDLE_VALUE) return;

		Stub_SLGetWindowsInformationDWORD.PushOp = 0x68;
		Stub_SLGetWindowsInformationDWORD.PushArg = (PLATFORM_DWORD)New_SLGetWindowsInformationDWORD;
		Stub_SLGetWindowsInformationDWORD.RetOp = 0xC3;

		Log = new char[1024];
		wsprintfA(Log, "Hook: SLGet patch: PushArg: %p\r\n", (PLATFORM_DWORD)New_SLGetWindowsInformationDWORD);
		WriteToLog(Log);
		delete[] Log;

		Result = ReadProcessMemory(GetCurrentProcess(), _SLGetWindowsInformationDWORD, &Old_SLGetWindowsInformationDWORD, sizeof(FARJMP), &bw);
		Log = new char[1024];
		wsprintfA(Log, "Hook: Read result: %i\r\n", Result);
		WriteToLog(Log);
		delete[] Log;

		Result = WriteProcessMemory(GetCurrentProcess(), _SLGetWindowsInformationDWORD, &Stub_SLGetWindowsInformationDWORD, sizeof(FARJMP), &bw);
		Log = new char[1024];
		wsprintfA(Log, "Hook: Write result: %i\r\n", Result);
		WriteToLog(Log);
		delete[] Log;
	
		if(OsVersion >= 0x0602) // if Windows 8 or higher
		{
			if(GetModuleCodeSectionInfo(hTermSrv, &TermSrvBase, &TermSrvSize))
			{
				WriteToLog("Hook: Windows 8 detected\r\n");
				PLATFORM_DWORD Win8SL_Func = SearchAddressBySignature((char*)TermSrvBase, TermSrvSize, Win8SL_FuncSign, sizeof(Win8SL_FuncSign));
				if(Win8SL_Func == -1) return;

				Log = new char[1024];
				wsprintfA(Log, "Hook: TermSrvBase: 0x%p SL address: 0x%p\r\n", TermSrvBase, Win8SL_Func);
				WriteToLog(Log);
				delete[] Log;

				Stub_Win8SL.PushOp = 0x68;
				Stub_Win8SL.PushArg = (PLATFORM_DWORD)New_Win8SL;
				Stub_Win8SL.RetOp = 0xC3;

				Log = new char[1024];
				wsprintfA(Log, "Hook: Trying to save original data... Base: 0x%p || 0x%p\r\n", (LPVOID)Win8SL_Func, Win8SL_Func);
				WriteToLog(Log);
				delete[] Log;

				ReadProcessMemory(GetCurrentProcess(), (LPVOID)Win8SL_Func, &Old_Win8SL, sizeof(FARJMP), &bw);
				WriteToLog("Hook: Orig Win 8 SL saved\r\n");
				WriteProcessMemory(GetCurrentProcess(), (LPVOID)Win8SL_Func, &Stub_Win8SL, sizeof(FARJMP), &bw);
				WriteToLog("Hook: Patch writed\r\n");
			}
		}
	}

	SetThreadsState(true);
	AlreadyHooked = true;
	WriteToLog("Retn: Hook\r\n");
	return;
}
#endif

void WINAPI ServiceMain(DWORD dwArgc, LPTSTR *lpszArgv)
{
	WriteToLog("Call: ServiceMain\r\n");
	if(!AlreadyHooked) Hook();

	if (_ServiceMain != NULL) _ServiceMain(dwArgc, lpszArgv);
	WriteToLog("Retn: ServiceMain\r\n");
}

void WINAPI SvchostPushServiceGlobals(void *lpGlobalData)
{
	WriteToLog("Call: SvchostPushServiceGlobals\r\n");
	if(!AlreadyHooked) Hook();
	//Sleep(60000);

	if (_SvchostPushServiceGlobals != NULL) _SvchostPushServiceGlobals(lpGlobalData); 
	WriteToLog("Retn: SvchostPushServiceGlobals\r\n");
}